INDIRECT returns the reference specified by a text string. References are immediately evaluated to display their contents. Use INDIRECT when you want to change the reference to a cell within a formula without changing the formula itself.
INDIRECT supports a1-style reference, r1c1-style reference, named reference, or a reference to a cell as a text string. For invalid cell references, INDIRECT returns the #REF! error value.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 });
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
var sheet = spread.sheets[0], sheet2 = spread.sheets[1];
sheet.setArray(0, 0, [["b1", 1], ["A", 2], ["B", 3]]);
sheet2.setArray(0, 0, [["b3", 1], ["A", 3], ["B", 5]]);
sheet.setValue(3, 0, "Random");
sheet.setFormula(3, 1, "=RANDBETWEEN(1,100)");
sheet.setValue(4, 0, "Now");
sheet.setFormula(4, 1, "=NOW()");
sheet.getRange(4, 1, 1, 1).formatter("mm-dd-yyyy");
sheet.setArray(8, 0, [["Formula", "Description", "Result"]]);
sheet.setColumnWidth(0, 165);
sheet.setColumnWidth(1, 285);
var sampleData = [
['=INDIRECT("A1")', 'Value of A1 => "b1"'],
['=INDIRECT(A1)', 'Value of the reference of A1 => value of b1 => 1'],
['=INDIRECT("A"&(1+2))', 'Value of A3 => "B"'],
['=INDIRECT(A3&B2)', 'Value of B2 => 2'],
['=INDIRECT("Sheet2!"&A1)', 'Value of Sheet2\'s B1'],
['=INDIRECT("Sheet2!A1")', 'Value of Sheet2\'s A1']
];
for (var i = 0, len = sampleData.length; i < len; i++) {
var data = sampleData[i], row = 6 + i;
sheet.setArray(row, 0, [data]);
sheet.setFormula(row, 2, data[0]);
}
spread.resumePaint();
document.getElementById("btnAddCustomName").addEventListener('click', function () {
var name = document.getElementById("customName").value,
ref = document.getElementById("customReference").value,
row = 15;
if (name) {
try {
sheet.addCustomName(name, ref, 0, 0);
sheet.setArray(row, 0, [[`=INDIRECT(${name})`, `${name} is a custom name, if a valid cell reference is defined by it then use the value otherwise #REF!`]]);
sheet.setFormula(row, 2, '=INDIRECT(' + name + ')');
} catch (e) {
alert("invalid custom name");
}
}
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
<label class="colorLabel">Enter a custom name below and set what it references. Then click the "Add custom name" button to add it to Spread for use in the cells.</label>
</div>
<div class="option-row">
<label class="sizedLabel">Custom name:</label>
<input type="text" value="name1" id="customName" />
</div>
<div class="option-row">
<label class="sizedLabel">Reference to:</label>
<input type="text" value="$A$1" id="customReference" />
</div>
<div class="option-row">
<input type="button" id="btnAddCustomName" value="Add custom name" title="Add a custom name for sample" />
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
margin-bottom: 12px;
}
input {
width: 100%;
padding: 4px 6px;
margin-bottom: 6px;
box-sizing: border-box;
}
input[type=button] {
width: auto;
}
label {
display: block;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

INDIRECT returns the reference specified by a text string. References are immediately evaluated to display their contents. Use INDIRECT when you want to change the reference to a cell within a formula without changing the formula itself.
INDIRECT supports a1-style reference, r1c1-style reference, named reference, or a reference to a cell as a text string. For invalid cell references, INDIRECT returns the #REF! error value.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label class="colorLabel">Enter a custom name below and set what it references. Then click the "Add
custom name" button to add it to Spread for use in the cells.</label>
</div>
<div class="option-row">
<label class="sizedLabel">Custom name:</label>
<input type="text" value="name1" id="customName" />
</div>
<div class="option-row">
<label class="sizedLabel">Reference to:</label>
<input type="text" value="$A$1" id="customReference" />
</div>
<div class="option-row">
<input type="button" id="btnAddCustomName" value="Add custom name" title="Add a custom name for sample"
@click="addIndirectCustomName($event)" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
let initSpread = function (spread) {
spreadRef.value = spread;
spread.suspendPaint();
let sheet = spread.sheets[0], sheet2 = spread.sheets[1];
sheet.setArray(0, 0, [["b1", 1], ["A", 2], ["B", 3]]);
sheet2.setArray(0, 0, [["b3", 1], ["A", 3], ["B", 5]]);
sheet.setValue(3, 0, "Random");
sheet.setFormula(3, 1, "=RANDBETWEEN(1,100)");
sheet.setValue(4, 0, "Now");
sheet.setFormula(4, 1, "=NOW()");
sheet.setArray(8, 0, [["Formula", "Description", "Result"]]);
sheet.setColumnWidth(0, 165);
sheet.setColumnWidth(1, 285);
let sampleData = [
['=INDIRECT("A1")', 'Value of A1 => "b1"'],
['=INDIRECT(A1)', 'Value of the reference of A1 => value of b1 => 1'],
['=INDIRECT("A"&(1+2))', 'Value of A3 => "B"'],
['=INDIRECT(A3&B2)', 'Value of B2 => 2'],
['=INDIRECT("Sheet2!"&A1)', 'Value of Sheet2\'s B1'],
['=INDIRECT("Sheet2!A1")', 'Value of Sheet2\'s A1']
];
for (let i = 0, len = sampleData.length; i < len; i++) {
let data = sampleData[i], row = 6 + i;
sheet.setArray(row, 0, [data]);
sheet.setFormula(row, 2, data[0]);
}
spread.resumePaint();
}
let addIndirectCustomName = function (e) {
let name = document.getElementById("customName").value,
ref = document.getElementById("customReference").value,
row = 15;
if (name) {
try {
let sheet = spreadRef.value.sheets[0];
sheet.addCustomName(name, ref, 0, 0);
sheet.setArray(row, 0, [[`=INDIRECT(${name})`, `${name} is a custom name, if a valid cell reference is defined by it then use the value otherwise #REF!`]]);
sheet.setFormula(row, 2, '=INDIRECT(' + name + ')');
} catch (e) {
alert("invalid custom name");
}
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input {
width: 100%;
padding: 4px 6px;
margin-bottom: 6px;
box-sizing: border-box;
}
input[type=button] {
width: auto;
}
label {
display: block;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

INDIRECT returns the reference specified by a text string. References are immediately evaluated to display their contents. Use INDIRECT when you want to change the reference to a cell within a formula without changing the formula itself.
INDIRECT supports a1-style reference, r1c1-style reference, named reference, or a reference to a cell as a text string. For invalid cell references, INDIRECT returns the #REF! error value.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.sheets[0], sheet2 = spread.sheets[1];
sheet.setArray(0, 0, [["b1", 1], ["A", 2], ["B", 3]]);
sheet2.setArray(0, 0, [["b3", 1], ["A", 3], ["B", 5]]);
sheet.setValue(3, 0, "Random");
sheet.setFormula(3, 1, "=RANDBETWEEN(1,100)");
sheet.setValue(4, 0, "Now");
sheet.setFormula(4, 1, "=NOW()");
sheet.setArray(8, 0, [["Formula", "Description", "Result"]]);
sheet.setColumnWidth(0, 165);
sheet.setColumnWidth(1, 285);
const sampleData = [
['=INDIRECT("A1")', 'Value of A1 => "b1"'],
['=INDIRECT(A1)', 'Value of the reference of A1 => value of b1 => 1'],
['=INDIRECT("A"&(1+2))', 'Value of A3 => "B"'],
['=INDIRECT(A3&B2)', 'Value of B2 => 2'],
['=INDIRECT("Sheet2!"&A1)', 'Value of Sheet2\'s B1'],
['=INDIRECT("Sheet2!A1")', 'Value of Sheet2\'s A1']
];
for (let i = 0, len = sampleData.length; i < len; i++) {
let data = sampleData[i], row = 6 + i;
sheet.setArray(row, 0, [data]);
sheet.setFormula(row, 2, data[0]);
}
spread.resumePaint();
}
addIndirectCustomName($event: any) {
let name = (document.getElementById("customName") as HTMLInputElement).value,
ref = (document.getElementById("customReference") as HTMLInputElement).value,
row = 15;
if (name) {
try {
let sheet = this.spread.sheets[0];
sheet.addCustomName(name, ref, 0, 0);
sheet.setArray(row, 0, [[`=INDIRECT(${name})`, `${name} is a custom name, if a valid cell reference is defined by it then use the value otherwise #REF!`]]);
sheet.setFormula(row, 2, '=INDIRECT(' + name + ')');
} catch (e) {
alert("invalid custom name");
}
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<label class="colorLabel">Enter a custom name below and set what it references. Then click the "Add custom name" button to add it to Spread for use in the cells.</label>
</div>
<div class="option-row">
<label class="sizedLabel">Custom name:</label>
<input type="text" value="name1" id="customName" />
</div>
<div class="option-row">
<label class="sizedLabel">Reference to:</label>
<input type="text" value="$A$1" id="customReference" />
</div>
<div class="option-row">
<input type="button" id="btnAddCustomName" value="Add custom name" title="Add a custom name for sample" (click)="addIndirectCustomName($event)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input {
width: 100%;
padding: 4px 6px;
margin-bottom: 6px;
box-sizing: border-box;
}
input[type=button] {
width: auto;
}
label {
display: block;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

INDIRECT returns the reference specified by a text string. References are immediately evaluated to display their contents. Use INDIRECT when you want to change the reference to a cell within a formula without changing the formula itself.
INDIRECT supports a1-style reference, r1c1-style reference, named reference, or a reference to a cell as a text string. For invalid cell references, INDIRECT returns the #REF! error value.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread,setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
var sheet = spread.sheets[0], sheet2 = spread.sheets[1];
sheet.setArray(0, 0, [["b1", 1], ["A", 2], ["B", 3]]);
sheet2.setArray(0, 0, [["b3", 1], ["A", 3], ["B", 5]]);
sheet.setValue(3, 0, "Random");
sheet.setFormula(3, 1, "=RANDBETWEEN(1,100)");
sheet.setValue(4, 0, "Now");
sheet.setFormula(4, 1, "=NOW()");
sheet.setArray(8, 0, [["Formula", "Description", "Result"]]);
sheet.setColumnWidth(0, 165);
sheet.setColumnWidth(1, 285);
var sampleData = [
['=INDIRECT("A1")', 'Value of A1 => "b1"'],
['=INDIRECT(A1)', 'Value of the reference of A1 => value of b1 => 1'],
['=INDIRECT("A"&(1+2))', 'Value of A3 => "B"'],
['=INDIRECT(A3&B2)', 'Value of B2 => 2'],
['=INDIRECT("Sheet2!"&A1)', 'Value of Sheet2\'s B1'],
['=INDIRECT("Sheet2!A1")', 'Value of Sheet2\'s A1']
];
for (var i = 0, len = sampleData.length; i < len; i++) {
var data = sampleData[i], row = 6 + i;
sheet.setArray(row, 0, [data]);
sheet.setFormula(row, 2, data[0]);
}
spread.resumePaint();
}
const addIndirectCustomName = (e) => {
var name = document.getElementById("customName").value,
ref = document.getElementById("customReference").value,
row = 15;
if (name) {
try {
var sheet = spread.sheets[0];
sheet.addCustomName(name, ref, 0, 0);
sheet.setArray(row, 0, [[`=INDIRECT(${name})`, `${name} is a custom name, if a valid cell reference is defined by it then use the value otherwise #REF!`]]);
sheet.setFormula(row, 2, '=INDIRECT(' + name + ')');
} catch (e) {
alert("invalid custom name");
}
}
}
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel addIndirectCustomName={(e) => addIndirectCustomName(e)} />
</div>;
}
function Panel(props) {
return (
<div class="options-container">
<div class="option-row">
<label class="colorLabel">Enter a custom name below and set what it references. Then click the "Add custom name" button to add it to Spread for use in the cells.</label>
</div>
<div class="option-row">
<label class="sizedLabel">Custom name:</label>
<input type="text" defaultValue="name1" id="customName" />
</div>
<div class="option-row">
<label class="sizedLabel">Reference to:</label>
<input type="text" defaultValue="$A$1" id="customReference" />
</div>
<div class="option-row">
<input type="button" id="btnAddCustomName" value="Add custom name" title="Add a custom name for sample" onClick={(e) => { props.addIndirectCustomName(e) }} />
</div>
</div>
);
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel addIndirectCustomName={(e) => { this.addIndirectCustomName(e) }} />
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
var sheet = spread.sheets[0], sheet2 = spread.sheets[1];
sheet.setArray(0, 0, [["b1", 1], ["A", 2], ["B", 3]]);
sheet2.setArray(0, 0, [["b3", 1], ["A", 3], ["B", 5]]);
sheet.setValue(3, 0, "Random");
sheet.setFormula(3, 1, "=RANDBETWEEN(1,100)");
sheet.setValue(4, 0, "Now");
sheet.setFormula(4, 1, "=NOW()");
sheet.setArray(8, 0, [["Formula", "Description", "Result"]]);
sheet.setColumnWidth(0, 165);
sheet.setColumnWidth(1, 285);
var sampleData = [
['=INDIRECT("A1")', 'Value of A1 => "b1"'],
['=INDIRECT(A1)', 'Value of the reference of A1 => value of b1 => 1'],
['=INDIRECT("A"&(1+2))', 'Value of A3 => "B"'],
['=INDIRECT(A3&B2)', 'Value of B2 => 2'],
['=INDIRECT("Sheet2!"&A1)', 'Value of Sheet2\'s B1'],
['=INDIRECT("Sheet2!A1")', 'Value of Sheet2\'s A1']
];
for (var i = 0, len = sampleData.length; i < len; i++) {
var data = sampleData[i], row = 6 + i;
sheet.setArray(row, 0, [data]);
sheet.setFormula(row, 2, data[0]);
}
spread.resumePaint();
}
addIndirectCustomName(e) {
var name = document.getElementById("customName").value,
ref = document.getElementById("customReference").value,
row = 15;
if (name) {
try {
var sheet = this.spread.sheets[0];
sheet.addCustomName(name, ref, 0, 0);
sheet.setArray(row, 0, [[`=INDIRECT(${name})`, `${name} is a custom name, if a valid cell reference is defined by it then use the value otherwise #REF!`]]);
sheet.setFormula(row, 2, '=INDIRECT(' + name + ')');
} catch (e) {
alert("invalid custom name");
}
}
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
<div class="option-row">
<label class="colorLabel">Enter a custom name below and set what it references. Then click the "Add custom name" button to add it to Spread for use in the cells.</label>
</div>
<div class="option-row">
<label class="sizedLabel">Custom name:</label>
<input type="text" defaultValue="name1" id="customName" />
</div>
<div class="option-row">
<label class="sizedLabel">Reference to:</label>
<input type="text" defaultValue="$A$1" id="customReference" />
</div>
<div class="option-row">
<input type="button" id="btnAddCustomName" value="Add custom name" title="Add a custom name for sample" onClick={(e) => { this.props.addIndirectCustomName(e) }} />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
input {
width: 100%;
padding: 4px 6px;
margin-bottom: 6px;
box-sizing: border-box;
}
input[type=button] {
width: auto;
}
label {
display: block;
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);